
def ts(A, B):
    """Resolve o sistema triangular superior Ax=B"""

    import copy

    # copia para variaveis locais
    a=copy.deepcopy(A)
    b=copy.deepcopy(B)

    # pega o tamanho de x
    n=len(b)
    # define X com zeros
    x=[0]*n

    # inicio do algoritmo
    x[n-1]=b[n-1]/a[n-1][n-1]
    for k in range(n-1, 0, -1):
        soma=b[k-1]
        for j in range(k+1, n+1):
            soma=soma-a[k-1][j-1]*x[j-1]
        x[k-1]=soma/a[k-1][k-1]
    return x


def eg(A,B):
    """Usa o metodo da Eliminacao Gaussiana para 
    transformar o sistema linear AX=B em um sistema Triangular superior,
    retornando a nova matriz At, triangular superior, e o vetor Bt, 
    tal que AtX=Bt tem a mesma solucao."""

    import copy

    # Necessario em Python quando trabalhando com matrizes e vetores
    a=copy.deepcopy(A)
    b=copy.deepcopy(B)

    # Obtem numero de equacoes a partir do tamanho do vetor b
    n=len(B)
    # Loop da primeira ate a penultima linha (de 1 ate n-1)
    for klin in range(1,n-1+1):
        #######################################
        # Aplica Pivoteamento
        w=abs(a[klin-1][klin-1])
        for jlin in range(klin,n+1):
           if abs(a[jlin-1][klin-1])>w:
              w=abs(a[jlin-1][klin-1])
              rlin=jlin
        # Terminado, troca as linhas "k" e "r"
        for jlin in range(1,n+1):
           vj=a[klin-1][jlin-1]
           a[klin-1][jlin-1]=a[rlin-1][jlin-1]
           a[rlin-1][jlin-1]=vj
        #########################################
        # Calcula novos valores de A e B
        for ilin in range(klin+1,n+1):
            m=a[ilin-1][klin-1]/a[klin-1][klin-1]
            b[ilin-1]=b[ilin-1]-m*b[klin-1]
            for jlin in range(klin+1,n+1):
               a[ilin-1][jlin-1]=a[ilin-1][jlin-1]-m*a[klin-1][jlin-1]

    return a,b

